function[err,vals]=arnR(A,m,v,lam,tol,maxits)
%--------------------------------------------
% [err, vals] = arnR (A,m,v,lam, tol, maxits)
% restarted  Arnoldi process 
%--------------------------------------------
 n = size(A,1);
res = 1.0; its = 0; tol1 = 0.0;
%--------------------------------------------
% start procedure
%-------------------------------------------- 
while (its < maxits  & res > tol1) 
  its = its+1;
  ro = norm(v,2)  ; 
  t = 1.0/ ro   ;
  V(:,1) = v*t; 
  v  = A*V(:,1) ;
  t  = v'*V(:,1) ;
  r = v - t*V(:,1);
  res = norm(r);
  if (its == 1) 
    tol1 = tol*res;
  end
  err(its)  = res;
%% 
for i=1:m  
   i1 = i + 1  ; 
   V(:,i1) = A*V(:,i)  ;
%--------------------------------------------
%                 modified GS  ;
%--------------------------------------------
 for j=1:i 
   t = V(:,j)'*V(:,i1)  ;
   H(j,i) = t  ;
   V(:,i1) = V(:,i1) - t*V(:,j)  ; 
  end  ;
%
  t = norm(V(:,i1),2)  ;
  H(i1,i) = t  ;
  if (t  ~= 0.0)  
   t = 1.0 / t  ;
   V(:,i1) = V(:,i1)*t  ;  
  end  
%--------------------------------------------
% define Arnoldi Objects 
%--------------------------------------------
  Vm = V(:,1:i);
  Hm = H(1:i,1:i);
%%%%%%%%%%%%%%%%%%%%%%%%%%%% Pure arnoldi 
  [X,vals] = eig(Hm);
  vals = diag(vals);
  [t, k] = min(abs(lam - vals));
 end
 v = V(:,1:i)*X(:,k) ;
end
