 function [A] = ldlt (A) 
%---------------------------------------------
% function [A] = ldlt (A) 
% performs LDLT factorization of a matrix A
% return the L matrix and the diagonal D
%---------------------------------------------
 n = size(A,1) ;
 piv = zeros(n,1);
 for k=1:n-1
     piv(k+1:n) = A(k+1:n,k)/A(k,k);
     for j=k+1:n
         A(j:n,j)=A(j:n,j)-piv(j:n)*A(j,k);
     end
     A(k+1:n,k) = piv(k+1:n);
 end
